<?php

namespace Modules\Chip\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Chip\Requests\Admin\ChipRequest;
use Modules\Chip\Services\ChipService;

class ChipController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/chips';
    /** View folder */
    private $viewDirectory= 'admin.chips.';
    //

    public function __construct(
        private ChipService $chipService,
    )
    {}

    /**
     * Display a listing of the chips.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('chips.head');
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the chips.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $chips= $this->chipService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new chip.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('chips.store');
        $head= __('chips.new');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created chip in storage.
     * @param ChipRequest $request
     * @return JsonResponse
     */
    public function store(ChipRequest $request) :JsonResponse
    {
        $this->chipService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified chip.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $chip = $this->chipService->getItem($id);
        if (!$chip)
        {
            abort(404);
        }
        $action= route('chips.update', $chip->id);

        $head= __('chips.edit');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified chip in storage.
     * @param ChipRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(ChipRequest $request, int $id) :JsonResponse
    {
        $chip = $this->chipService->checkItem($id);
        if (!$chip)
        {
            abort(404);
        }
        $this->chipService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified chip from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->chipService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several chips by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->chipService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified chip from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->chipService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several chips by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->chipService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('chips.index'),
        ];
        return ResponseService::response($response);
    }
}
